import { Alert, useDataGrid } from '@/components';
import { useCallback, useState } from 'react';
import { apiConfig } from '@/config/api.config';
import { useCallApi } from '@/hooks';
import { toast } from 'sonner';
import {
  Dialog,
  DialogContent,
  DialogFooter,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Button } from '@/components/ui/button';
import { DialogDescription } from '@radix-ui/react-dialog';
import { useManageRewardContext } from '../hooks/useManageRewardContext';
import { doSaveLogActivity } from '@/actions/GlobalActions';

const API_URL = apiConfig.service_master_data;

const DeleteDialog = () => {
  const { showDeleteDialog, handleDeleteDialog, selectedReward } = useManageRewardContext();
  const { reload } = useDataGrid();
  const { DeleteData } = useCallApi();
  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });

  // console.log('ini data :', selectedReward);

  const doDeleteReward = useCallback(async () => {
    if (!selectedReward) {
      toast.error('No Reward selected');
      return;
    }
    // console.log('Ini datanya:', selectedReward);
    const response = await DeleteData(`${API_URL}/reward/delete/${selectedReward}/true`, {
      id: selectedReward
    });
    // console.log('Response Delete:', response);

    if (response?.status) {
      setAlert((prev) => ({ ...prev, show: false, message: '' }));
      handleDeleteDialog(false, null);
      toast.success('Success Delete Reward');
      reload();
      const createActivity = {
        module: 'Manage Reward',
        description: `Delete Reward => ${selectedReward}`,
        action: 'D'
      };

      doSaveLogActivity(createActivity);
    } else {
      setAlert((prev) => ({ ...prev, show: true, message: response?.message }));
      toast.error('Failed Delete Reward');
    }
  }, [selectedReward, DeleteData, handleDeleteDialog, reload]);

  return (
    <Dialog open={showDeleteDialog} onOpenChange={(open) => handleDeleteDialog(open, null)}>
      <DialogContent className="container-fixed max-w-md flex flex-col p-5 overflow-hidden [&>button]:hidden">
        <DialogHeader className="p-0 border-0 block">
          <DialogTitle></DialogTitle>
          <DialogDescription></DialogDescription>
          <Alert variant="warning">
            <h3 className="text-lg">Are you sure?</h3>
            <span className="text-sm">You will delete this data!</span>
          </Alert>
          {alert.show && (
            <Alert variant="danger">
              <h3>{alert.message}</h3>
            </Alert>
          )}
        </DialogHeader>
        <DialogFooter className="flex justify-end items-center gap-4 mt-3">
          <Button variant="outline" onClick={() => handleDeleteDialog(false, null)}>
            Cancel
          </Button>
          <Button variant="destructive" onClick={doDeleteReward}>
            Delete
          </Button>
        </DialogFooter>
      </DialogContent>
    </Dialog>
  );
};

export default DeleteDialog;
